/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.HubunganKeluargaDao;
import com.portofolio.dto.HubunganKeluargaDto;
import com.portofolio.entity.HubunganKeluarga;
import com.portofolio.entity.vo.HubunganKeluargaId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class HubunganKeluargaService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private HubunganKeluargaDao hubunganKeluargaDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(HubunganKeluargaDto hubunganKeluargaDto) {
		result.clear();
		HubunganKeluargaId id = new HubunganKeluargaId();
		Integer kdHubunganKeluarga =getIdTerahir(HubunganKeluarga.class.getSimpleName());
		id.setKdHubunganKeluarga(kdHubunganKeluarga);
		id.setKdProfile(getKdProfile());
		HubunganKeluarga hubunganKeluarga = CommonUtil.findOne(hubunganKeluargaDao, id);
		if (CommonUtil.isNullOrEmpty(hubunganKeluarga)) {
			hubunganKeluarga = new HubunganKeluarga();
			BeanUtils.copyProperties(hubunganKeluargaDto, hubunganKeluarga);
			hubunganKeluarga.setNoRec(generateUuid32());
			hubunganKeluarga.setVersion(1);
			hubunganKeluarga.setId(id);
			hubunganKeluarga = hubunganKeluargaDao.save(hubunganKeluarga);
			result.put("hubunganKeluarga", hubunganKeluarga);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("hubunganKeluarga.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(HubunganKeluargaDto hubunganKeluargaDto, Integer kdHubunganKeluarga, Integer version) {
		result.clear();
		HubunganKeluargaId id = new HubunganKeluargaId();
		id.setKdHubunganKeluarga(kdHubunganKeluarga);
		id.setKdProfile(getKdProfile());
		HubunganKeluarga hubunganKeluarga = CommonUtil.findOne(hubunganKeluargaDao, id);
		if (CommonUtil.isNotNullOrEmpty(hubunganKeluarga)) {
			if (version < hubunganKeluarga.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(hubunganKeluargaDto, hubunganKeluarga);
			hubunganKeluarga.setVersion(version);
			hubunganKeluarga = hubunganKeluargaDao.save(hubunganKeluarga);
			result.put("hubunganKeluarga", hubunganKeluarga);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaHubunganKeluarga,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaHubunganKeluarga)) {
			pageRes = hubunganKeluargaDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = hubunganKeluargaDao.findAllList(getKdProfile(), namaHubunganKeluarga, statusEnabled, pageReq);
		}
		result.put("hubunganKeluarga", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdHubunganKeluarga(Integer kdHubunganKeluarga) {
		result.clear();
		result.put("hubunganKeluarga", hubunganKeluargaDao.findByKdHubunganKeluarga(getKdProfile(), kdHubunganKeluarga, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdHubunganKeluarga, Integer version) {
		result.clear();
		HubunganKeluargaId id = new HubunganKeluargaId();
		id.setKdHubunganKeluarga(kdHubunganKeluarga);
		id.setKdProfile(getKdProfile());
		HubunganKeluarga hubunganKeluarga = CommonUtil.findOne(hubunganKeluargaDao, id);
		if (CommonUtil.isNotNullOrEmpty(hubunganKeluarga)) {
			if (version < hubunganKeluarga.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			hubunganKeluarga.setStatusEnabled(false);
			hubunganKeluarga.setVersion(version);
			hubunganKeluarga = hubunganKeluargaDao.save(hubunganKeluarga);
			result.put("hubunganKeluarga", hubunganKeluarga);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
